export declare abstract class Exception {
    message: string;
    protected constructor(message: string);
}
export declare class APIException extends Exception {
    statusCode: number;
    requestURL: string;
    responseData: any;
    errorId: string | null;
    errorCode: string | null;
    constructor(message: string, statusCode: number, requestURL: string, responseData: any, errorId: string | null, errorCode: string | null);
}
export declare class NetworkConnectionException extends Exception {
    constructor(requestURL: string);
}
export declare class RuntimeException extends Exception {
    errorObject: any;
    constructor(message: string, errorObject: any);
}
export declare class ReactLifecycleException extends Exception {
    message: string;
    componentStack: string;
    constructor(message: string, componentStack: string);
}
